#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int n, sz[MAXN + 5];
unsigned long long l[MAXN + 5];
vector< pair<int, unsigned long long> > G[MAXN + 5];

struct path
{
    int v, sz;
    unsigned long long w;

    path(int v, int sz, unsigned long long w)
    {
        this -> v = v;
        this -> sz = sz;
        this -> w = w;
    }
};

vector<path> G2[MAXN + 5];

void DFS(int u, int p)
{
    sz[u] = 1;
    for (auto [v, w] : G[u])
    {
        if (v != p)
        {
            DFS(v, u);
            sz[u] += sz[v];
            unsigned long long x = l[v] + 1ll * sz[v] * w;
            l[u] += x;
            G2[u].emplace_back(v, sz[v], x);
        }
    }
}

void DFS2(int u, int p, unsigned long long w)
{
    if (p != -1)
    {
        unsigned long long x = l[p] - (l[u] + 1ll * sz[u] * w) + 1ll * (n - sz[u]) * w;
        l[u] += x;
        G2[u].emplace_back(p, n - sz[u], x);
    }
    for (auto [v, w] : G[u])
    {
        if (v != p)
        {
            DFS2(v, u, w);
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;

    for (int i = 1; i < n; ++ i)
    {
        int u, v;
        unsigned long long w;
        cin >> u >> v >> w;
        G[u].emplace_back(v, w);
        G[v].emplace_back(u, w);
    }

    DFS(1, -1);
    DFS2(1, -1, -1);

    for (int u = 1; u <= n; ++ u)
    {
        unsigned long long sum = 0;
        for (auto t : G2[u])
        {
            sum += 1ll * t.w * (n - t.sz);
        }
        cout << sum << endl;
    }

    return 0;
}
