#include <iostream>
#define endl '\n'
using namespace std;

const int MAXK = 1000;

struct number
{
    int digits[MAXK + 5];
};

number idle;

number multiply(number &a, number &b)
{
    number c = idle;
    for (int i = 0; i < MAXK; ++ i)
    {
        for (int j = 0; i + j < MAXK; ++ j)
        {
            c.digits[i + j] += a.digits[i] * b.digits[j];
        }
    }

    for (int i = 0; i < MAXK; ++ i)
    {
        c.digits[i + 1] += c.digits[i] / 10;
        c.digits[i] %= 10;
    }
    return c;
}

number fast_pow(number a, long long b)
{
    number ret = idle;
    ret.digits[0] = 1;
    while (b)
    {
        if (b & 1) ret = multiply(ret, a);
        b >>= 1;
        a = multiply(a, a);
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;

    while (t--)
    {
        long long a, b, k;
        cin >> a >> b >> k;

        int cnt = 0;
        number x = idle;
        while (a)
        {
            x.digits[cnt] = a % 10;
            cnt++;
            a /= 10;
        }

        number t = fast_pow(x, b);
        cout << t.digits[k - 1] << endl;
    }

    return 0;
}
