#include <iostream>
#include <string>
#define endl '\n'
using namespace std;

const int MAXK = 1000;

int c[MAXK + 5];
string idle = "";

string multiply(string &a, string &b)
{
    for (int i = 0; i < MAXK; ++ i)
    {
        for (int j = 0; i + j < MAXK; ++ j)
        {
            c[i + j] += (a[i] - '0') * (b[j] - '0');
        }
    }

    string ret = "";
    for (int i = 0; i < MAXK; ++ i)
    {
        c[i + 1] += c[i] / 10;
        c[i] %= 10;
        ret += char(c[i] + '0');
        c[i] = 0;
    }
    return ret;
}

string fast_pow(string a, long long b)
{
    string ret = idle;
    ret[0] = '1';
    while (b)
    {
        if (b & 1) ret = multiply(ret, a);
        b >>= 1;
        a = multiply(a, a);
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    for (int i = 0; i < MAXK; ++ i)
    {
        idle += '0';
    }

    int t;
    cin >> t;

    while (t--)
    {
        long long a, b, k;
        cin >> a >> b >> k;

        int cnt = 0;
        string x = idle;
        while (a)
        {
            x[cnt] = char(a % 10 + '0');
            cnt++;
            a /= 10;
        }

        string s = fast_pow(x, b);
        cout << s[k - 1] << endl;
    }

    return 0;
}
