#include <iostream>
#define endl '\n'
using namespace std;

const int MAXK = 125;
const int BASE = 100000000;

struct number
{
    long long d[MAXK + 5];
};

number idle;

number multiply(number &a, number &b)
{
    number c = idle;
    for (int i = 0; i < MAXK; ++ i)
    {
        for (int j = 0; i + j < MAXK; ++ j)
        {
            c.d[i + j] += a.d[i] * b.d[j];
            if (i + j + 1 < MAXK) c.d[i + j + 1] += c.d[i + j] / BASE;
            c.d[i + j] %= BASE;
        }
    }

    for (int i = 0; i < MAXK; ++ i)
    {
        c.d[i + 1] += c.d[i] / BASE;
        c.d[i] %= BASE;
    }
    return c;
}

number fast_pow(number a, long long b)
{
    number ret = idle;
    ret.d[0] = 1;
    while (b)
    {
        if (b & 1) ret = multiply(ret, a);
        b >>= 1;
        a = multiply(a, a);
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;

    while (t--)
    {
        long long a, b, k;
        cin >> a >> b >> k;

        int cnt = 0;
        number x = idle;
        while (a)
        {
            x.d[cnt] = a % BASE;
            cnt++;
            a /= BASE;
        }

        number t = fast_pow(x, b);

        int i = (k - 1) / 8, j = (k - 1) % 8;
        while (j)
        {
            t.d[i] /= 10;
            j--;
        }
        cout << t.d[i] % 10 << endl;
    }

    return 0;
}
