#include<bits/stdc++.h>
#define endl '\n'
#define llong long long
using namespace std;

vector<vector<char>> allPossibleSigns;
int n, k;

void printC(vector<char> signs)
{
    for(auto c: signs)
        cout << c << " ";
    cout << endl;
}

void printI(vector<int> numbers)
{
    for(auto c: numbers)
        cout << c << " ";
    cout << endl;
}
int signIncrement[8] = {1024, 256, 64, 16, 4, 1};

//                      possible values
vector<int> MergeGroups(vector<int> left, vector<int> right) // calculates this -> ( ... )[*/+-]( ... )
{
    vector<int> finalValues;
    for(int i = 0; i < left.size(); i++)
    {
        for(int j = 0; j < right.size(); j++)
        {
            finalValues.push_back( left[i]+right[i] );
            finalValues.push_back( left[i]-right[i] );
            finalValues.push_back(-left[i]+right[i] );
            finalValues.push_back( left[i]-right[i] );

            finalValues.push_back( left[i] * right[i] );
            finalValues.push_back(-left[i] * right[i] );

            if(left[i]%right[i] == 0)
            {
                finalValues.push_back( left[i] / right[i] );
                finalValues.push_back(-left[i] / right[i] );
            }
        }
    }
    return finalValues;
}

bool isIncorrect = false;
int sum = 0;
int CalculateNumbersAndSigns(vector<int> numbers, vector<char> signs)
{
    sum = 0;
    int current = numbers[0] * (signs[0] == '-' ? -1 : 1);
    for(int i = 1; i < numbers.size(); i++)
    {
        if(signs[i] == '+' || signs[i] == '-')
        {
            sum += current;
            current = numbers[i] * (signs[i] == '-' ? -1 : 1);
        }
        else if(signs[i] == '*') current *= numbers[i];
        else
        {
            if(numbers[i] == 0 || current % numbers[i] != 0)
            {
                isIncorrect = true;
                return 0;
            }
            current /= numbers[i];
        }
    }
    sum += current;
    return sum;
}

vector<int> Possibilities(vector<int> numbers) // calculates value in ( ... )
{
    vector<int> retValue;
    int numberCount = numbers.size();
    for(int i = 0; i < 512; i += signIncrement[numberCount])
    {
        isIncorrect = false;
        CalculateNumbersAndSigns(numbers, allPossibleSigns[i]);
        if(isIncorrect) continue;
        retValue.push_back(sum);
    }
    return retValue;
}

// returns posibilities
vector<int> Skobi(vector<int> numbers) // uses the merge and possibilities functions
{
    vector<int> retValue;
    int numberCount = numbers.size();
    if(numberCount < 3)
    {
        retValue = Possibilities(numbers);
    }
    else
    {
        vector<int> temp;
        vector<vector<int>> lefts;
        vector<vector<int>> rights;

        for(int i = 0; i < numberCount-1; i++)
            lefts.push_back(temp), rights.push_back(temp);

        for(int i = 0;             i < numberCount-1; i++)
            for(int j = 0; j < i+1; j++)
                lefts[i].push_back(numbers[j]);

        for(int i = numberCount-2; i >= 0;            i--)
            for(int j = 0; j < i+1; j++)
                rights[i].push_back(numbers[j]);

        retValue = Possibilities(numbers); // takes the whole

        vector<int> leftsGroup, rightsGroup; // the possibilities of separation
        for(int i = 0; i < numberCount-1; i++)
        {
            // the whole plus more division
            leftsGroup = Skobi(lefts[i]);
            rightsGroup = Skobi(rights[i]);
            temp = MergeGroups(leftsGroup, rightsGroup);
            for(auto e: temp) retValue.push_back(e);
        }
    }
    return retValue;
}

vector<int> Digify(int number)
{
    vector<int> digits;
    if(number == 0) digits.push_back(0);
    while(number != 0) digits.push_back(number%10), number /= 10;
    return vector<int>(digits.rbegin(), digits.rend());
}

int DigitCount(int number)
{
    int br = 0;
    if(number == 0) br = 1;
    while(number != 0) number/=10, br++;
    return br;
}

bool CheckPossibilitues(vector<int> numbers)
{
    for(auto e: numbers) if(e == k) return true;
    return false;
}

bool Calculate(int number) // concatenates and calculates all possibilities
{
    if(CheckPossibilitues(Skobi({number}))) return true; // abc...

    int digitCount = DigitCount(number);
    vector<int> digits = Digify(number);
    // manually calculate concatenations
    if(digitCount == 2)
    {
        if(CheckPossibilitues(Skobi({digits[0], digits[1]}))) return true; // a b
    }
    else if(digitCount == 3)
    {
        if(CheckPossibilitues(Skobi({digits[0], digits[1], digits[2]}))) return true; // a b c
        if(CheckPossibilitues(Skobi({digits[0]*10+digits[1], digits[2]}))) return true; // ab c
        if(CheckPossibilitues(Skobi({digits[0], digits[1]*10+digits[2]}))) return true; // a bc
    }
    else if(digitCount == 4)
    {
        if(CheckPossibilitues(Skobi({digits[0], digits[1], digits[2], digits[3]}))) return true; // a b c d
        if(CheckPossibilitues(Skobi({digits[0]*10+digits[1], digits[2], digits[3]}))) return true; // ab c d
        if(CheckPossibilitues(Skobi({digits[0], digits[1]*10+digits[2], digits[3]}))) return true; // a bc d
        if(CheckPossibilitues(Skobi({digits[0], digits[1], digits[2]*10+digits[3]}))) return true; // a b cd
        if(CheckPossibilitues(Skobi({digits[0]*10+digits[1], digits[2]*10+digits[3]}))) return true; // ab cd
        if(CheckPossibilitues(Skobi({digits[0]*100+digits[1]*10+digits[2], digits[3]}))) return true; // abc d
        if(CheckPossibilitues(Skobi({digits[0], digits[1]*100+digits[2]*10+digits[3]}))) return true; // a bcd
    }
    else if(digitCount == 5)
    {
        if(CheckPossibilitues(Skobi({digits[0], digits[1], digits[2], digits[3], digits[4]}))) return true; // a b c d e
        if(CheckPossibilitues(Skobi({digits[0]*10+digits[1], digits[2], digits[3], digits[4]}))) return true; // ab c d e
        if(CheckPossibilitues(Skobi({digits[0], digits[1]*10+digits[2], digits[3], digits[4]}))) return true; // a bc d e
        if(CheckPossibilitues(Skobi({digits[0], digits[1], digits[2]*10+digits[3], digits[4]}))) return true; // a b cd e
        if(CheckPossibilitues(Skobi({digits[0]*10+digits[1], digits[2], digits[3], digits[4]}))) return true; // ab c d e
        if(CheckPossibilitues(Skobi({digits[0], digits[1], digits[2], digits[3]*10+digits[4]}))) return true; // a b c de
        if(CheckPossibilitues(Skobi({digits[0]*10+digits[1], digits[2]*10+digits[3], digits[4]}))) return true; // ab cd e
        if(CheckPossibilitues(Skobi({digits[0]*10+digits[1], digits[2], digits[3]*10+digits[4]}))) return true; // ab c de
        if(CheckPossibilitues(Skobi({digits[0], digits[1]*10+digits[2], digits[3]*10+digits[4]}))) return true; // a bc de
        if(CheckPossibilitues(Skobi({digits[0]*100+digits[1]*10+digits[2], digits[3], digits[4]}))) return true; // abc d e
        if(CheckPossibilitues(Skobi({digits[0], digits[1]*100+digits[2]*10+digits[3], digits[4]}))) return true; // a bcd e
        if(CheckPossibilitues(Skobi({digits[0], digits[1], digits[2]*100+digits[3]*10+digits[4]}))) return true; // a b cde
        if(CheckPossibilitues(Skobi({digits[0], digits[1]*1000+digits[2]*100+digits[3]*10+digits[4]}))) return true; // a bcde
        if(CheckPossibilitues(Skobi({digits[0]*1000+digits[1]*100+digits[2]*10+digits[3], digits[4]}))) return true; // abcd e
    }
    return false;
}

void CreateAllPossibleSigns(vector<char> current, int left)
{
    if(left == 0)
    {
        allPossibleSigns.push_back(current);
        return;
    }
    if(current.size() >= 1)
    {
        if(current[0] == '*') return;
        if(current[0] == '/') return;
    }
    current.push_back('+');
    CreateAllPossibleSigns(current, left-1);
    current.pop_back();
    current.push_back('-');
    CreateAllPossibleSigns(current, left-1);
    current.pop_back();
    current.push_back('*');
    CreateAllPossibleSigns(current, left-1);
    current.pop_back();
    current.push_back('/');
    CreateAllPossibleSigns(current, left-1);
    current.pop_back();
}

// THE MOST READABLE CODE EVER
int main()
{
    vector<char> init;
    CreateAllPossibleSigns(init, 5);
    cin >> n >> k;
    int answer = 0;
    for(int i = 0; i <= n; i++)
        if(Calculate(i)) answer++;
    cout << answer << endl;
    return 0;
}
