#include<iostream>
#include<queue>

using namespace std;

int numberOfRoads[10005];
int roads[10005][10005];
int sum[10005];

vector<int> nextRoad[10005];

bool visited[10005];

int n;

queue<int> order;

void calculate(int nodeNow, int sumNow)
{
    visited[nodeNow] = true;

    for(int i = 0;i < nextRoad[nodeNow].size();i++)
    {
        int nextNode = nextRoad[nodeNow][i];
        if(roads[nodeNow][nextNode] >= 1 && !visited[nextNode])
        {
            calculate(nextNode, sumNow + roads[nodeNow][nextNode]);
        }
    }

    for(int i = 1;i <= n;i++)
    {
        if(visited[i])
        {
            sum[i] += sumNow;
        }
    }

    visited[nodeNow] = false;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n;

    for(int i = 0;i < n - 1;i++)
    {
        int a,b,l;

        cin>>a>>b>>l;

        numberOfRoads[a]++;
        numberOfRoads[b]++;

        roads[a][b] = l;
        roads[b][a] = l;

        nextRoad[a].push_back(b);
        nextRoad[b].push_back(a);
    }

    for(int i = 1;i <= n; i++)
    {
        if(numberOfRoads[i] == 1)
        {
            order.push(i);
        }
    }

    while(!order.empty())
    {
        int i = order.front();
        order.pop();
        if(numberOfRoads[i] == 1)
        {
            calculate(i, 0);

            numberOfRoads[i]--;

            numberOfRoads[nextRoad[i][0]]--;
            roads[i][nextRoad[i][0]] = 0;
            roads[nextRoad[i][0]][i] = 0;

            if(numberOfRoads[nextRoad[i][0]] == 1)
            {
                order.push(nextRoad[i][0]);
            }
        }
    }

    for(int i = 1;i <= n;i++)
    {
        cout<<sum[i]<<endl;
    }
}
