#include<iostream>
#include<queue>

using namespace std;

int numberOfRoads[10005];
int roads[10005][10005];
int sum[10005];

bool visited[10005];

int n;

queue<int> order;

int calculate(int nodeNow, int sumNow)
{
    visited[nodeNow] = true;

    int totalSum = sumNow;

    for(int i = 1;i <= n;i++)
    {
        if(roads[nodeNow][i] >= 1 && !visited[i])
        {
            int tempSum = calculate(i, sumNow + roads[nodeNow][i]);
            totalSum += tempSum;
        }
    }

    sum[nodeNow] += totalSum;
    visited[nodeNow] = false;

    return totalSum;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n;

    for(int i = 0;i < n - 1;i++)
    {
        int a,b,l;

        cin>>a>>b>>l;

        numberOfRoads[a]++;
        numberOfRoads[b]++;

        roads[a][b] = l;
        roads[b][a] = l;
    }

    for(int i = 1;i <= n; i++)
    {
        if(numberOfRoads[i] == 1)
        {
            order.push(i);
        }
    }

    while(!order.empty())
    {
        int i = order.front();
        order.pop();
        if(numberOfRoads[i] == 1)
        {
            calculate(i, 0);

            numberOfRoads[i]--;

            for(int j = 1;j <= n;j++)
            {
                if(roads[i][j] >= 1)
                {
                    numberOfRoads[j]--;
                    roads[i][j] = 0;
                    roads[j][i] = 0;

                    if(numberOfRoads[j] == 1)
                    {
                        order.push(j);
                    }

                    break;
                }
            }
        }
    }

    for(int i = 1;i <= n;i++)
    {
        cout<<sum[i]<<endl;
    }
}
