#include<iostream>
#include<queue>

using namespace std;

long long numberOfRoads[10005];
long long roads[10005][10005];
long long sum[10005];

bool visited[10005];

long long n;

queue<long long> order;

vector<long long> nextRoad[10005];

long long calculate(long long nodeNow, long long sumNow)
{
    visited[nodeNow] = true;

    long long totalSum = sumNow;

    for(long long i = 0;i < nextRoad[nodeNow].size();i++)
    {
        long long nextNode = nextRoad[nodeNow][i];

        if(!visited[nextNode])
        {
            long long tempSum = calculate(nextNode, sumNow + roads[nodeNow][nextNode]);
            totalSum += tempSum;
        }
    }

    sum[nodeNow] += totalSum;
    visited[nodeNow] = false;

    return totalSum;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n;

    for(long long i = 0;i < n - 1;i++)
    {
        long long a,b,l;

        cin>>a>>b>>l;

        numberOfRoads[a]++;
        numberOfRoads[b]++;

        nextRoad[a].push_back(b);
        nextRoad[b].push_back(a);

        roads[a][b] = l;
        roads[b][a] = l;
    }

    for(long long i = 1;i <= n; i++)
    {
        if(numberOfRoads[i] == 1)
        {
            order.push(i);
        }
    }

    while(!order.empty())
    {
        long long i = order.front();
        order.pop();
        if(numberOfRoads[i] == 1)
        {
            calculate(i, 0);

            numberOfRoads[i]--;

            long long nextNode = nextRoad[i][0];

            long long indx = 0;

            for(long long j = 0;j < nextRoad[nextNode].size();j++)
            {
                if(nextRoad[nextNode][j] == i)
                {
                    indx = j;
                    break;
                }
            }

            numberOfRoads[nextNode]--;

            nextRoad[i].clear();
            nextRoad[nextNode].erase(nextRoad[nextNode].begin() + indx);

            roads[i][nextNode] = 0;
            roads[nextNode][i] = 0;

            if(numberOfRoads[nextNode] == 1)
            {
                order.push(nextNode);
            }
        }
    }

    for(long long i = 1;i <= n;i++)
    {
        cout<<sum[i]<<endl;
    }
}
