#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <utility> 

#define ll long long

ll grading[100001] = {0};
std::vector<std::vector<int> > paths;

int corner_node(std::vector<std::pair<int, int> > graph[], int n){
	for(int i = 1; i <= n; i++){
		if(graph[i].size() == 1) return i;
	}	
	return 1;
}

std::vector<int> corner_nodes(std::vector<std::pair<int, int> > graph[], int n){
	std::vector<int> result;
	for(int i = 1; i <= n; i++){
		if(graph[i].size() == 1) result.push_back(i);
	}	
	return result;

}

void update(std::vector<int> v, int value){
	for(int i = 0; i < v.size(); i++) grading[v[i]] += value;
}

bool vector_contains(std::vector<int> v, int value){
	for(int i = 0; i < v.size(); i++) if(v[i] == value) return true;
	return false;
}

void vector_print(std::vector<int> v){
	for(int i = 0; i < v.size(); i++) printf("%d ", v[i]);
	printf("\n");
}

void traverse_(int s, std::vector<std::pair<int, int> > graph[], int n, std::vector<int> prev_trav, std::vector<int> trav_corners, int prev_dis){
	std::vector<int> traversed(prev_trav);
		//paths.push_back(std::vector<int>(prev_trav));
		//paths[paths.size() - 1].push_back(prev_dis);
	for(int i = 0; i < graph[s].size(); i++){
		if(vector_contains(traversed, graph[s][i].first) || vector_contains(trav_corners, graph[s][i].first)) continue;
		traversed.push_back(graph[s][i].first);

		paths.push_back(std::vector<int>(traversed));
		paths[paths.size() - 1].push_back(graph[s][i].second + prev_dis);
		//vector_print(prev_trav);
		//vector_print(traversed);

		//update(traversed, graph[s][i].second);
		//update(prev_trav, prev_dis);
		traverse_(graph[s][i].first, graph, n, traversed, trav_corners, graph[s][i].second + prev_dis);	
		traversed.erase(traversed.begin() + traversed.size() - 1);
	}
}

void traverse(std::vector<std::pair<int, int> > graph[], int n){
	//int s = corner_node(graph, n); // vzimame node, kojto ima samo 1 vruzka
	std::vector<int> corners = corner_nodes(graph, n);
	std::vector<int> trav_corners;

	for(int j = 0; j < corners.size(); j++){
		int s = corners[j];
		std::vector<int> traversed(1, s);
		trav_corners.push_back(s);	
		for(int i = 0; i < graph[s].size(); i++){
			traversed.push_back(graph[s][i].first);
			update(traversed, graph[s][i].second);
			traverse_(graph[s][i].first, graph, n, traversed, trav_corners, graph[s][i].second);
			traversed.erase(traversed.begin() + traversed.size() - 1);
		}
	}
	std::vector<int> traversed;
	for(int i = 1; i <= n; i++){
		if(vector_contains(corners, i)) continue;
		for(int j = 0; j < graph[i].size(); j++){
			if(vector_contains(corners, graph[i][j].first) || vector_contains(traversed, graph[i][j].first)) continue;		
			grading[i] += graph[i][j].second;
			grading[graph[i][j].first] += graph[i][j].second;
			traversed.push_back(i);
		}
	}	
}

void solve(std::vector<std::pair<int, int> > graph[], int n){
	traverse(graph, n);
	for(int i = 0; i < paths.size(); i++){
		int l = paths[i][paths[i].size() - 1];
		for(int j = 0; j < paths[i].size() - 1; j++) grading[paths[i][j]] += l;
	}
			
	for(int i = 1; i <= n; i++){
		printf("%lld\n", grading[i]);
	}	
}

int main(){
	ll n;
	scanf("%lld", &n);
	std::vector<std::pair<int, int> > graph[n+1];
	// first - kum koi node, second - distanciqta
	for(int i = 1; i < n; i++){
		int u, v, l;
		scanf("%d %d %d", &u, &v, &l);
		graph[u].push_back(std::make_pair(v, l));
		graph[v].push_back(std::make_pair(u, l));
	}
	solve(graph, n);
	return 0;
}
