#include <iostream>
#include <vector>
#include <string.h>
using namespace std;

struct station
{
    int stop;
    unsigned short distance_to_stop;
};

int curr_stop = 0;

void dfs(vector<station> stations[], bool visited[], long long distances[], int curr, int res, unsigned short distance)
{
    visited[curr] = true;
    distances[res] += distance;
    for (int i = 0; i < stations[curr].size(); i++)
    {
        if (visited[stations[curr][i].stop] == false)
        {
            distances[curr] += distance;

            distance += stations[curr][i].distance_to_stop;
            dfs(stations, visited, distances, stations[curr][i].stop, res, distance);
            distance -= stations[curr][i].distance_to_stop;
        }
    }    
}

int main()
{
    int n;
    cin >> n;

    vector<station> stations[n + 1];
    bool visited[n + 1] = {false};
    long long distances[n + 1] = {0};

    int x, y;
    unsigned short l;
    for (int i = 0; i < n - 1; i++)
    {
        cin >> x >> y >> l;
        struct station st1 = {y, l};
        struct station st2 = {x, l};
        stations[x].push_back(st1);
        stations[y].push_back(st2);
    }

    for (int i = 1; i < n + 1; i++)
    {
        dfs(stations, visited, distances, i, i, 0);
        memset(visited, 0, n + 1);
    }
    for (int i = 1; i < n + 1; i++)
        cout << distances[i] << "\n";

    return 0;
}
/*

6
1 2 3
1 4 5
3 4 7
4 5 9
4 6 10

*/
