#include<iostream>
#include<vector>

using namespace std;

const int MAX = 1e5 + 1;

vector<int> e[MAX];
vector<int> ls[MAX];
vector<int> path;

bool vis[MAX];
long long dist[MAX], curr_path_dist = 0;
int n;


bool find_path(int curr, int to)
{
    vis[curr] = true;

    if(curr == to)
        return true;

    for(int i = 0;i < e[curr].size();i++)
    {
        int child = e[curr][i];
        if (!vis[child] && find_path(child, to))
        {
            path.push_back(child);
            curr_path_dist += ls[curr][i];
            return true;
        }
    }
    return false;
}

void clear()
{
    for(int i = 1;i <= n;i++)
        vis[i] = false;
    path.clear();
    curr_path_dist = 0;
}

void calculate_path(int from , int to)
{
    find_path(from, to);
    path.push_back(from);
    for(int c_p : path)
        dist[c_p] += curr_path_dist;
    clear();
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    cin >>  n;

    for(int i = 0,a ,b, l;i < n - 1;i++)
    {
        cin >> a >> b >> l;

        e[a].push_back(b);
        e[b].push_back(a);

        ls[a].push_back(l);
        ls[b].push_back(l);

    }


    for(int i = 1;i <= n;i++)
        for(int j = i + 1;j <= n;j++)
            calculate_path(i, j);

    for(int i = 1;i <= n;i++)
        cout << dist[i] << "\n";

    return 0;
}