#include<iostream>
#include<vector>
#include<math.h>
using namespace std;

vector<int> revers(vector<int> a)
{
    vector<int> b;
    for(int i = a.size() - 1;i >= 0;i--)
        b.push_back(a[i]);
    return b;
}

vector<int> multiplication_simple(vector<int> a, int b)
{
    vector<int> out;
    int in_mind = 0;
    for(int i = a.size() - 1;i >= 0;i--)
    {
        int p = a[i] * b + in_mind;
        out.push_back(p % 10);
        in_mind = p / 10;
    }
    if(in_mind)
        out.push_back(in_mind);

    return revers(out);
}

vector<int> plus_(vector<int> a, vector<int>b )
{
    vector<int> out;
    int i = a.size() - 1, j = b.size() - 1, in_mind = 0;

    for (;i >= 0 && j >= 0;i--, j--)
    {
        int p = a[i] + b[j] + in_mind;
        int e = p % 10;
        out.push_back(e);
        in_mind = p / 10;
    }

    if(a.size() > b.size())
    {
        for(;i >= 0;i--)
        {
            int p = a[i] + in_mind;
            int e = p % 10;
            out.push_back(e);
            in_mind = p / 10;
        }
    }

    if(b.size() > a.size())
    {
        for(;j >= 0;j--)
        {
            int p = b[j] + in_mind;
            int e = p % 10;
            out.push_back(e);
            in_mind = p / 10;
        }
    }
    if(in_mind)
        out.push_back(in_mind);

    return revers(out);
}


vector<int> multiplication(const vector<int> &a, vector<int> b)
{
    vector<int> out;
    int start = 0;
    bool first = false;
    for(int i = a.size() - 1;i >= 0;i--)
    {
        if (first)
        {
            vector<int> c = multiplication_simple(b, a[i]);
            for(int j = 0;j < start;j++)
                c.push_back(0);

            out = plus_(out, c);
        }
        else
        {
            out = multiplication_simple(b, a[i]);
            first = true;
        }

        start ++;
    }

    return out;
}

vector<int> from_string_to_vector(const string &a)
{
    vector<int> out;
    for(int i = 0;i < a.size();i++)
        out.push_back(a[i] - '0');

    return out;
}

vector<int> power_(vector<int> a, long long b)
{
    vector<int> res = multiplication(a, a);
    for(int i = 2;i < b;i++)
    {
        res = multiplication(res, a);
    }
    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    long long t;

    cin >> t;

    for(int p = 0,k;p < t;p++)
    {
        string h;
        long long q;
        cin >> h >> q >> k;

        vector<int> a = from_string_to_vector(h);
        vector<int> c = power_(a, q);
        for(int i = c.size() - 1, j = 1;i >= 0;i--, j++)
        {
            if(j == k)
                cout << c[i] << "\n";
        }
    }

    return 0;
}