#include <stdio.h>
#include <stdlib.h>

#define MAX_N 100000

struct Edge;
struct Node;

struct Edge {
    int64_t cost;
    struct Edge *next;
    struct Node *from;
    struct Node *to;
};

struct Node {
    int64_t cost;
    struct Edge *edges;
};

struct Node nodes[MAX_N];

int64_t edges_len = 0;
struct Edge edges[MAX_N * 2];

void add_dir_edge(struct Node *from, struct Node *to, int64_t cost) {
    edges[edges_len] = {
        .cost = cost,
        .next = from->edges,
        .from = from,
        .to   = to,
    };
    from->edges = &edges[edges_len];
    ++edges_len;
}

void add_edge(struct Node *a, struct Node *b, int64_t cost) {
    add_dir_edge(a, b, cost);
    add_dir_edge(b, a, cost);
}

int64_t dfs(struct Node *root, struct Node *from, int64_t cost) {
    int64_t sum = cost;
    for (struct Edge *e = root->edges; e; e = e->next) {
        if (e->to == from) continue;
        sum += dfs(e->to, root, cost + e->cost);
    }
    root->cost += sum;
    return sum;
}

int main() {
    int64_t n;
    scanf("%lld", &n);
    for (int64_t i = 0; i < n-1; ++i) {
        int64_t a, b, cost;
        scanf("%lld%lld%lld", &a, &b, &cost);
        --a;
        --b;
        add_edge(&nodes[a], &nodes[b], cost);
    }

    for (int64_t i = 0; i < n; ++i) {
        dfs(&nodes[i], NULL, 0);
    }
    for (int64_t i = 0; i < n; ++i) {
        printf("%lld\n", nodes[i].cost/2);
    }
}
/*
6
1 2 3
1 4 5
3 4 7
4 5 9
4 6 10
*/
