#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;
const __int128 maxn = 1e5+10, base = (1ll << 30), maxd = 100;

int64_t a, b, k;
vector < __int128 > mult(const vector < __int128 > &a, const vector < __int128 > &b) {

    vector < __int128 > ans(maxd, 0);
    __int128 prenos;
    for (__int128 i = 0 ; i < min((__int128)a.size(), maxd) ; ++i) {
     
        prenos = 0;
        for (__int128 j = 0 ; (j < b.size() || prenos) && i+j < maxd ; ++j) {

            if (j < b.size()) prenos += a[i]*b[j];
            ans[i+j] += prenos;
            prenos = ans[i+j] / base;
            ans[i+j] %= base;

        }

    }

    return ans;

}

vector < int > mult_10(const vector < int > &a, const vector < int > &b) {

    vector < int > ans(k, 0);
    int prenos;
    for (int i = 0 ; i < min((int64_t)a.size(), k) ; ++i) {
     
        prenos = 0;
        for (int j = 0 ; (j < b.size() || prenos) && i+j < k ; ++j) {

            if (j < b.size()) prenos += a[i]*b[j];
            ans[i+j] += prenos;
            prenos = ans[i+j] / 10;
            ans[i+j] %= 10;

        }

    }

    return ans;

}

vector < int > add_10(const vector < int > &a, const vector < int > &b) {

    vector < int > ans(k, 0);
    int prenos = 0;
    for (int i = 0 ; i < k && (i < max(a.size(), b.size()) || prenos) ; ++i) {
     
        if (i < a.size()) prenos += a[i];
        if (i < b.size()) prenos += b[i];
        ans[i] = prenos % 10;
        prenos /= 10;

    }

    return ans;

}

vector < int > convert_10(__int128 num) {

    vector < int > res;
    while (num > 0 && res.size() < k) {

        res.push_back(num % 10);
        num /= 10;

    }

    if (res.empty()) res.push_back(0);
    return res;

}

void from_binary(const vector < __int128 > &a) {

    vector < int > res(k, 0);
    vector < int > two = convert_10(base);

    for (int i = a.size()-1 ; i >= 0 ; --i) {

        res = mult_10(res, two);
        res = add_10(res, convert_10(a[i]));

    }

    cout << res[k-1] << '\n';

}

vector < __int128 > ans, curr;
void solve() {

    cin >> a >> b >> k;
    
    ans.clear();
    ans.push_back(1);
    curr.clear();

    while (a > 0) {

        curr.push_back(a%base);
        a /= base;

    }

    for (__int128 i = 0 ; (1ll << i) <= b ; ++i) {

        if ((b & (1ll << i)) != 0) ans = mult(ans, curr);
        curr = mult(curr, curr);

    }
   
    from_binary(ans);
    

}


void fast_io() {

    ios_base :: sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);

}

int64_t t;
signed main () {

    fast_io();
    cin >> t;

    while (t--) 
        solve();


    return 0;

}
