#include <iostream>
#include <cassert>
#include <map>
using namespace std;
const int inf = 1e9;

struct key {

    int b[6];
    key(){}
    key(int b1, int b2, int b3, int b4, int b5, int last) {

        b[0] = b1;
        b[1] = b2;
        b[2] = b3;
        b[3] = b4;
        b[4] = b5;
        b[5] = last;

    }
    inline friend bool operator < (key a, key b) {

        for (int i = 0 ; i < 6 ; ++i)
            if (a.b[i] != b.b[i]) return a.b[i] < b.b[i];
        return 0;

    }

};

int b[6], b2[6];
map < key, int > m;

int f(int b1, int b2, int b3, int b4, int b5, int last) {

    if (b1+b2+b3+b4+b5 == 0) return 0;
    if (m.count({b1, b2, b3, b4, b5, last})) return m[{b1, b2, b3, b4, b5, last}];

    int res = inf;
    if (b1 >= 1) res = min(res, f(b1-1, b2, b3, b4, b5, 1) + max(0, last + 1 - 5) );
    if (b2 >= 1) res = min(res, f(b1, b2-1, b3, b4, b5, 2) + max(0, last + 2 - 5) );
    if (b3 >= 1) res = min(res, f(b1, b2, b3-1, b4, b5, 3) + max(0, last + 3 - 5) );
    if (b4 >= 1) res = min(res, f(b1, b2, b3, b4-1, b5, 4) + max(0, last + 4 - 5) );
    if (b5 >= 1) res = min(res, f(b1, b2, b3, b4, b5-1, 5) + max(0, last + 5 - 5) );

    return m[{b1, b2, b3, b4, b5, last}] = res;


}

void solve_dp() {

    cout << f(b[1], b[2], b[3], b[4], b[5], 0) << '\n';

}

void solve_greedy_1() {

    int sum = 0, last = 0, ans = 0;
    for (int i = 5 ; i >= 1 ; --i) {

        sum += b[i];
        if (b[i] != 0) last = max(last, i);

    }

    --b[last];
    --sum;

    for (int i = 1 ; i <= sum ; ++i) {

        bool bl = 0;
        for (int j = 5-last ; j >= 1 && !bl ; --j) {

            if (b[j] >= 1) {

                --b[j];
                last = j;
                bl = 1;

            }

        }

        for (int j = 5-last+1 ; j <= 5 && !bl ; ++j) {

            if (b[j] >= 1) {

                --b[j];
                ans += last + j - 5;
                last = j;
                bl = 1;

            }

        }

        assert(bl);

    }

    cout << ans << '\n';

}

void solve_greedy_2() {

    for (int i = 1 ; i <= 5 ; ++i)
        b2[i] = b[i];
        
    int l = 1, r = 5, ans = 0;

    while (b[l] == 0) ++l;
    while (b[r] == 0) --r;

    int last = 0, ans2 = 0;
    while (l <= r) {

        ans += (min(b[l], b[r]) + (b[l] != b[r])*min(b[l], b[r]) - 1) * max(0, l + r - 5) + max(0, last + r - 5);
        int removed = min(b[l], b[r]);
        b[l] -= removed;
        if (l != r) b[r] -= removed;
        last = l;
        if (b[l] == 0) ++l;
        if (b[r] == 0) --r;

    }

    l = 1;
    r = 5;

    while (b2[l] == 0) ++l;
    while (b2[r] == 0) --r;

    while (l <= r) {

        ans2 += (min(b2[l], b2[r]) + (b2[l] != b2[r])*min(b2[l], b2[r]) - 1) * max(0, l + r - 5) + max(0, last + l - 5);
        int removed = min(b2[l], b2[r]);
        b2[l] -= removed;
        if (l != r) b2[r] -= removed;
        last = r;
        while (b2[l] == 0) ++l;
        while (b2[r] == 0) --r;

    }
    
    cout << min(ans2, ans) << '\n';

}

int ans;
int main () {
    
    cin >> b[1] >> b[2] >> b[3] >> b[4] >> b[5];
    if (b[1]+b[2]+b[3]+b[4]+b[5] <= 100) solve_dp();
    else if (b[1]+b[2]+b[3]+b[4]+b[5] > 2000)  solve_greedy_1();
    else solve_greedy_2();

    return 0;

}